#include <stddef.h>
#include <stdlib.h>
#include <avr/io.h>
#include <avr/pgmspace.h>

#include "time.h"

void localtime(const time_t t, struct tm * tms_p)
{
  int16_t days;
  uint8_t  y,m;	
  ldiv_t lresult;
  div_t result;
  uint8_t  m_index 		= 0;
  uint8_t  m_days		= 31;
  
  
   lresult 			= ldiv(t, 86400UL);
   days 			= (int16_t) lresult.quot;
   tms_p->tm_wday	= (days + TIME_WDAY_ZERO) % 7;
   lresult 			= ldiv(lresult.rem, 3600);
   tms_p->tm_hour 	= lresult.quot;
   result 			= div(lresult.rem, 60);
   tms_p->tm_min 	= result.quot;
   tms_p->tm_sec 	= result.rem;

   result			= div(days, 365);
   y				= result.quot;
   days				= (int16_t) result.rem;
   days				-= ((y+3) >> 2);
   if(days < 0){
                 y--;
				 days += 365;
				 if((y & 0x03) == 0) days++;
               }
   m = 0;
   if((y & 0x03) && (days >= 59)) days++;			// Kein Schaltjahr

   while(days >= m_days){
                          m++;
					      days -= m_days;
						  m_index++;
						  m_days = pgm_read_byte(days_of_month + m_index);
                    }			   				

   tms_p->tm_mday = days +1;
   tms_p->tm_mon  = m;
   tms_p->tm_year = y;
}

