#include <stddef.h>
#include <stdlib.h>
#include <avr/io.h>
#include <avr/pgmspace.h>

#include "time.h"

time_t mktime (struct tm * tms_p)
{
  uint16_t days 	= tms_p->tm_mday -1;
  uint8_t  y 		= tms_p->tm_year;
  uint8_t  m 		= tms_p->tm_mon;


  
  while(m--) days += pgm_read_byte(days_of_month + m);

  if((y & 0x03) && (days >= 60)) days--; 	// kein Schaltjahr;

  days += y * 365 + ((y+3) >>2);

  return 86400UL * days + 3600UL * tms_p->tm_hour + 60 * tms_p->tm_min + tms_p->tm_sec;
}
